Module javafx.graphics
Package javafx.scene.effect

# Class Reflection

java.lang.Object
javafx.scene.effect.Effect
javafx.scene.effect.Reflection

    public class Reflection
    extends Effect

An effect that renders a reflected version of the input below the actual input content.

Note that the reflection of a `Node` with a `Reflection` effect installed will not respond to mouse events or the containment methods on the `Node`.

Example:

     Reflection reflection = new Reflection();
     reflection.setFraction(0.7);

     Text text = new Text();
     text.setX(10.0);
     text.setY(50.0);
     text.setCache(true);
     text.setText("Reflections on JavaFX...");
     text.setFill(Color.web("0x3b596d"));
     text.setFont(Font.font(null, FontWeight.BOLD, 40));
     text.setEffect(reflection);

The code above produces the following:

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type | Property | Description
  --- | --- | ---
  `DoubleProperty` | `bottomOpacity` | The bottom opacity value, which is the opacity of the reflection at its bottom extreme.
  `DoubleProperty` | `fraction` | The fraction of the input that is visible in the reflection.
  `ObjectProperty<Effect>` | `input` | The input for this `Effect`.
  `DoubleProperty` | `topOffset` | The top offset adjustment, which is the distance between the bottom of the input and the top of the reflection.
  `DoubleProperty` | `topOpacity` | The top opacity value, which is the opacity of the reflection at its top extreme.

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `Reflection()` | Creates a new instance of Reflection with default parameters.
  `Reflection​(double topOffset, double fraction, double topOpacity, double bottomOpacity)` | Creates a new instance of Reflection with the specified topOffset, fraction, topOpacity and bottomOpacity.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `DoubleProperty` | `bottomOpacityProperty()` | The bottom opacity value, which is the opacity of the reflection at its bottom extreme.
  `DoubleProperty` | `fractionProperty()` | The fraction of the input that is visible in the reflection.
  `double` | `getBottomOpacity()` | Gets the value of the property bottomOpacity.
  `double` | `getFraction()` | Gets the value of the property fraction.
  `Effect` | `getInput()` | Gets the value of the property input.
  `double` | `getTopOffset()` | Gets the value of the property topOffset.
  `double` | `getTopOpacity()` | Gets the value of the property topOpacity.
  `ObjectProperty<Effect>` | `inputProperty()` | The input for this `Effect`.
  `void` | `setBottomOpacity​(double value)` | Sets the value of the property bottomOpacity.
  `void` | `setFraction​(double value)` | Sets the value of the property fraction.
  `void` | `setInput​(Effect value)` | Sets the value of the property input.
  `void` | `setTopOffset​(double value)` | Sets the value of the property topOffset.
  `void` | `setTopOpacity​(double value)` | Sets the value of the property topOpacity.
  `DoubleProperty` | `topOffsetProperty()` | The top offset adjustment, which is the distance between the bottom of the input and the top of the reflection.
  `DoubleProperty` | `topOpacityProperty()` | The top opacity value, which is the opacity of the reflection at its top extreme.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Property Details

  - ### input

    public final ObjectProperty<Effect> inputProperty
    The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null
    See Also:
      `getInput()`, `setInput(Effect)`

  - ### topOffset

    public final DoubleProperty topOffsetProperty
    The top offset adjustment, which is the distance between the bottom of the input and the top of the reflection.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getTopOffset()`, `setTopOffset(double)`

  - ### topOpacity

    public final DoubleProperty topOpacityProperty
    The top opacity value, which is the opacity of the reflection at its top extreme.

               Min: 0.0
               Max: 1.0
           Default: 0.5
          Identity: 1.0

    Default value:
      0.5
    See Also:
      `getTopOpacity()`, `setTopOpacity(double)`

  - ### bottomOpacity

    public final DoubleProperty bottomOpacityProperty
    The bottom opacity value, which is the opacity of the reflection at its bottom extreme.

               Min: 0.0
               Max: 1.0
           Default: 0.0
          Identity: 1.0

    Default value:
      0.0
    See Also:
      `getBottomOpacity()`, `setBottomOpacity(double)`

  - ### fraction

    public final DoubleProperty fractionProperty
    The fraction of the input that is visible in the reflection. For example, a value of 0.5 means that only the bottom half of the input will be visible in the reflection.

               Min: 0.0
               Max: 1.0
           Default: 0.75
          Identity: 1.0

    Default value:
      0.75
    See Also:
      `getFraction()`, `setFraction(double)`

- ## Constructor Details

  - ### Reflection

    public Reflection()
    Creates a new instance of Reflection with default parameters.

  - ### Reflection

    public Reflection​(double topOffset, double fraction, double topOpacity, double bottomOpacity)
    Creates a new instance of Reflection with the specified topOffset, fraction, topOpacity and bottomOpacity.
    Parameters:
      `topOffset` - the distance between the bottom of the input and the top of the reflection
      `fraction` - the fraction of the input that is visible in the reflection
      `topOpacity` - the opacity of the reflection at its top extreme
      `bottomOpacity` - the opacity of the reflection at its bottom extreme
    Since:
      JavaFX 2.1

- ## Method Details

  - ### setInput

    public final void setInput​(Effect value)
    Sets the value of the property input.
    Property description:
      The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null

  - ### getInput

    public final Effect getInput()
    Gets the value of the property input.
    Property description:
      The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null

  - ### inputProperty

    public final ObjectProperty<Effect> inputProperty()
    The input for this `Effect`. If set to `null`, or left unspecified, a graphical image of the `Node` to which the `Effect` is attached will be used as the input.
    Default value:
      null
    See Also:
      `getInput()`, `setInput(Effect)`

  - ### setTopOffset

    public final void setTopOffset​(double value)
    Sets the value of the property topOffset.
    Property description:
      The top offset adjustment, which is the distance between the bottom of the input and the top of the reflection.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### getTopOffset

    public final double getTopOffset()
    Gets the value of the property topOffset.
    Property description:
      The top offset adjustment, which is the distance between the bottom of the input and the top of the reflection.

                 Min: n/a
                 Max: n/a
             Default: 0.0
            Identity: 0.0

    Default value:
      0.0

  - ### topOffsetProperty

    public final DoubleProperty topOffsetProperty()
    The top offset adjustment, which is the distance between the bottom of the input and the top of the reflection.

               Min: n/a
               Max: n/a
           Default: 0.0
          Identity: 0.0

    Default value:
      0.0
    See Also:
      `getTopOffset()`, `setTopOffset(double)`

  - ### setTopOpacity

    public final void setTopOpacity​(double value)
    Sets the value of the property topOpacity.
    Property description:
      The top opacity value, which is the opacity of the reflection at its top extreme.

                 Min: 0.0
                 Max: 1.0
             Default: 0.5
            Identity: 1.0

    Default value:
      0.5

  - ### getTopOpacity

    public final double getTopOpacity()
    Gets the value of the property topOpacity.
    Property description:
      The top opacity value, which is the opacity of the reflection at its top extreme.

                 Min: 0.0
                 Max: 1.0
             Default: 0.5
            Identity: 1.0

    Default value:
      0.5

  - ### topOpacityProperty

    public final DoubleProperty topOpacityProperty()
    The top opacity value, which is the opacity of the reflection at its top extreme.

               Min: 0.0
               Max: 1.0
           Default: 0.5
          Identity: 1.0

    Default value:
      0.5
    See Also:
      `getTopOpacity()`, `setTopOpacity(double)`

  - ### setBottomOpacity

    public final void setBottomOpacity​(double value)
    Sets the value of the property bottomOpacity.
    Property description:
      The bottom opacity value, which is the opacity of the reflection at its bottom extreme.

                 Min: 0.0
                 Max: 1.0
             Default: 0.0
            Identity: 1.0

    Default value:
      0.0

  - ### getBottomOpacity

    public final double getBottomOpacity()
    Gets the value of the property bottomOpacity.
    Property description:
      The bottom opacity value, which is the opacity of the reflection at its bottom extreme.

                 Min: 0.0
                 Max: 1.0
             Default: 0.0
            Identity: 1.0

    Default value:
      0.0

  - ### bottomOpacityProperty

    public final DoubleProperty bottomOpacityProperty()
    The bottom opacity value, which is the opacity of the reflection at its bottom extreme.

               Min: 0.0
               Max: 1.0
           Default: 0.0
          Identity: 1.0

    Default value:
      0.0
    See Also:
      `getBottomOpacity()`, `setBottomOpacity(double)`

  - ### setFraction

    public final void setFraction​(double value)
    Sets the value of the property fraction.
    Property description:
      The fraction of the input that is visible in the reflection. For example, a value of 0.5 means that only the bottom half of the input will be visible in the reflection.

                 Min: 0.0
                 Max: 1.0
             Default: 0.75
            Identity: 1.0

    Default value:
      0.75

  - ### getFraction

    public final double getFraction()
    Gets the value of the property fraction.
    Property description:
      The fraction of the input that is visible in the reflection. For example, a value of 0.5 means that only the bottom half of the input will be visible in the reflection.

                 Min: 0.0
                 Max: 1.0
             Default: 0.75
            Identity: 1.0

    Default value:
      0.75

  - ### fractionProperty

    public final DoubleProperty fractionProperty()
    The fraction of the input that is visible in the reflection. For example, a value of 0.5 means that only the bottom half of the input will be visible in the reflection.

               Min: 0.0
               Max: 1.0
           Default: 0.75
          Identity: 1.0

    Default value:
      0.75
    See Also:
      `getFraction()`, `setFraction(double)`